//+------------------------------------------------------------------+
//|                                                 EAGhostrad.mq4 |
//|                                          Copyright  2014,. |
//|                                             |
//|                                                     |
//|                                               |
//| I DONT NEED PIPS, I NEED MONEY                                   |
//+------------------------------------------------------------------+
extern int StartTime = 0;
extern int StopTime = 0; 

extern int PipDistance = 10;
extern int Slippage = 7;

extern double OP1Lot = 0.01;
extern double OP2Lot = 0.01;
extern double OP3Lot = 0.01;
extern double OP4Lot = 0.01;
extern double OP5Lot = 0.01;
extern double OP6Lot = 0.01;
extern double OP7Lot = 0.01;
extern double OP8Lot = 0.0;   //bila 0 maka nggak akan dibuka
extern double OP9Lot = 0.0;

extern double SecureProfit = 30.0;   //bila menyentuh ini maka close all
extern int SecureOP = 1;             //banyaknya OP untuk mengaktifkan SecureProfit 

extern int MagicNumber = 1397;

extern bool Debug = false;
string ExpertName = "EAGhostrad";

double Spread = 0;
int OPSelanjutnya = OP_BUY;
double PriceSell_SL,Price2S,PriceSell_OP,PriceSell_TP;
double PriceBuy_TP,PriceBuy_OP,Price3B,PriceBuy_SL;
double profit;
bool ForceCloseAll = false;

//
double MyPoint;
double LuckyPoint;
double StopLevel;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----

   Comment("Init...");
   
   //supaya nggak problem dengan digit berapa saja..
   MyPoint = MarketInfo(Symbol(), MODE_POINT); 
   StopLevel = MarketInfo(Symbol(), MODE_STOPLEVEL); 
   if(MyPoint == 0.000001) 
   {
      StopLevel = StopLevel * 0.1;
   }
   if(MyPoint <= 0.0001) 
   {
      MyPoint = 0.0001; 
      LuckyPoint = 10000;
   }   
   else if(MyPoint == 0.001) 
   {
      LuckyPoint = 1000;
   }
   else if(MyPoint == 0.01) 
   {
      LuckyPoint = 100;
   }
   else if(MyPoint == 0.1) 
   {
      LuckyPoint = 10;
   }
   else if(MyPoint == 1) 
   {
      LuckyPoint = 1;
   }  
   
   //Ambil spread
   Spread = Ask - Bid;
   
   //cek kalo masih ada Open Order
   //dan setting price
   if(OrdersTotal()>0)
   {
      if(Debug == true) Print("Init Hitung Price");
      
      for (int i = 0; i < OrdersTotal(); i++) 
      { 
         if(OrderSelect(i, SELECT_BY_POS,MODE_TRADES) == true)
         { 
            if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderCloseTime() == 0) 
            { 
                  //proses cari price
                  if(OrderType() == OP_SELL)
                  {
                     PriceSell_OP = OrderOpenPrice();
                     PriceSell_TP = PriceSell_OP  - PipDistance *  MyPoint;
                     Price2S = PriceSell_OP  + PipDistance * MyPoint;
                     PriceSell_SL = Price2S  + PipDistance * MyPoint;
              
                     PriceBuy_TP = PriceSell_SL;
                     PriceBuy_OP = Price2S;
                     Price3B = PriceSell_OP;
                     PriceBuy_SL = PriceSell_TP;
                  }
                  else
                  if(OrderType() == OP_BUY)
                  {
                     PriceBuy_OP = OrderOpenPrice();
                     PriceBuy_TP = PriceBuy_OP  + PipDistance * MyPoint;
                     Price3B = PriceBuy_OP  - PipDistance * MyPoint;
                     PriceBuy_SL = Price3B  - PipDistance * MyPoint;
              
                     PriceSell_SL = PriceBuy_TP;
                     Price2S = PriceBuy_OP;
                     PriceSell_OP = Price3B;
                     PriceSell_TP = PriceBuy_SL;
                  }
                  break;
            } 
         } 
      }       
   }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----

   //harus tutup semua
   //dijamin nggak ada yg ketinggalan.. 
   if(ForceCloseAll == true)
   {
      CloseAll();
      if(CheckPair(MagicNumber) == false)
      {
         Comment("wAIT", "\nClose All....");
         ForceCloseAll = false;
      }
      return(0);
   }

   int i, OPSell=0, OPBuy=0, OPSellStop=0, OPBuyStop=0, OPLast=99;
   int Ticket, OPtotal=0;
   double LotSelanjutnya = 0;
   
   //hitung OP 
   if(Debug == true) Print("Logic#1 Hitung yg OP");

   profit = 0;
   for (i = 0; i < OrdersTotal(); i++) 
   { 
      if(OrderSelect(i, SELECT_BY_POS,MODE_TRADES) == true)
      { 
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderCloseTime() == 0) 
         { 
               OPLast = OrderType();   
               Ticket = OrderTicket();   
               profit = profit + OrderProfit();
               if(OrderType() == OP_BUY)  OPBuy++; 
               if(OrderType() == OP_SELL) OPSell++;  
               if(OrderType() == OP_SELLSTOP) OPSellStop++;  
               if(OrderType() == OP_BUYSTOP) OPBuyStop++;
               OPtotal++;
         } 
      } 
   } 
   
   if     (OPtotal == 0) LotSelanjutnya = OP1Lot;
   else if(OPtotal == 1) LotSelanjutnya = OP2Lot;
   else if(OPtotal == 2) LotSelanjutnya = OP3Lot;
   else if(OPtotal == 3) LotSelanjutnya = OP4Lot;
   else if(OPtotal == 4) LotSelanjutnya = OP5Lot;
   else if(OPtotal == 5) LotSelanjutnya = OP6Lot;
   else if(OPtotal == 6) LotSelanjutnya = OP7Lot;
   else if(OPtotal == 7) LotSelanjutnya = OP8Lot;
   else if(OPtotal == 8) LotSelanjutnya = OP9Lot;
   else LotSelanjutnya = 0;

   OPtotal = OPBuy + OPSell;
   
   //untuk mengamankan profit
   if(SecureOP > 0 && SecureOP <= OPtotal && SecureProfit > 0 && SecureProfit <= profit)
   {
      ForceCloseAll = true;
      return(0);     
   }

   //maintenance orderstop double
   if(OPSellStop > 1 || OPBuyStop > 1)
   {
      //tutup semua order, nanti di Logic#4 dibuka lagi 
      //kenapa ada ini: tadi ada request yg timeout tapi tiba-tiba saja ada double
      if(Debug == true) Print("Error: Orderstop lebih dari 1 -- DELETE");
      DeleteSatuOrderStop();
      
      return(0);     
   }
      
   Comment("EA", 
           "\n\n Total OP_BUY = ",  OPBuy,
           "\n Total OP_SELL = ",  OPSell,
           "\n Total OP_BUYSTOP = ",  OPBuyStop,
           "\n Total OP_SELLSTOP = ",  OPSellStop,
           "\n\n Spread = ",  Spread,
           "\n StopLevel = ",  StopLevel,
           "\n PriceSell_OP = ", PriceSell_OP,
           "\n PriceSell_TP = ", PriceSell_TP,
           "\n PriceSell_SL = ", PriceSell_SL,
           "\n PriceBuy_OP = ", PriceBuy_OP,
           "\n PriceBuy_TP = ", PriceBuy_TP,
           "\n PriceBuy_SL = ", PriceBuy_SL,
           "\n\n SecureOP = ", SecureOP,
           "\n TotalOP = ", OPtotal,
           "\n\n SecureProfit = ", SecureProfit,
           "\n Profit = ", profit,
           "\n\n Equity = ", AccountEquity(),
           "\n Balance = ", AccountBalance());
           
   //cek ada OP nggak
   if(OPBuy == 0 && OPSell == 0)
   {
      if(Debug == true) Print("Logic#2 Open Posisi");
      
      //tentukan arah ---------------------------
      if(OPSellStop>0) OPSelanjutnya = OP_BUY; 
      else if(OPBuyStop>0) OPSelanjutnya = OP_SELL; 
      
      //cek masih ada nggak OPStop yang menggantung
      if(OPSellStop > 0 || OPBuyStop > 0)
      {
         //tutup semua order  
         if(Debug == true) Print("Logic#2 DeleteOrderStop");
         
         ForceCloseAll = true;
         return(0);     
      }
      
      //Filter by Time
      if(TradeTime() == false) return(0);

      //kalau mau pake indicator mulai disini ---
      // OPSelanjutnya = OP_BUY --> BUY yg pertama
      // OPSelanjutnya = OP_SELL --> SELL yg pertama
      //-----------------------------------------
      //         
      
      OPSelanjutnya = GetSignal();
      
      //OP sudah kosong
      if(OPSelanjutnya == OP_SELL)  //sell
      {
         if(Debug == true) Print("Logic#2 OP pertama SELL");
         
         RefreshRates();
         Ticket = OpenOrder(OP_SELL, OP1Lot, Bid, 0, 0, Red);
         if(Ticket < 0) return(0);
         else 
         {
            OPSell = 1; 
            OPLast = OP_SELL; 
            LotSelanjutnya = OP2Lot;
         }
      }
      else
      {
         if(Debug == true) Print("Logic#2 OP pertama BUY");
         
         RefreshRates();
         Ticket = OpenOrder(OP_BUY, OP1Lot, Ask, 0, 0, Blue);
         if(Ticket < 0) return(0);
         else 
         {
            OPBuy = 1; 
            OPLast = OP_BUY; 
            LotSelanjutnya = OP2Lot;
         }
      }
      
   }

   //cek baru 1 buy atau 1 sell tidak ada buystop atau sellstop
   if(((OPBuy == 1 && OPSell == 0) || (OPBuy == 0 && OPSell == 1)) && (OPBuyStop == 0 && OPSellStop == 0))
   {
      if(Debug == true) Print("Logic#3 Hitung Price");
      
      if(OPLast == OP_SELL)
      {
         //hitung price yg diperlukan
         if(OrderSelect(Ticket, SELECT_BY_TICKET) == true)
         {
              if(Debug == true) Print("Logic#3 Hitung Price - SELL");
              
              PriceSell_OP = OrderOpenPrice();
              PriceSell_TP = PriceSell_OP  - PipDistance * MyPoint;
              Price2S = PriceSell_OP  + PipDistance * MyPoint;
              PriceSell_SL = Price2S  + PipDistance * MyPoint;
              
              PriceBuy_TP = PriceSell_SL;
              PriceBuy_OP = Price2S;
              Price3B = PriceSell_OP;
              PriceBuy_SL = PriceSell_TP;
              
              
              //Modify TP & SL
              if(OrderStopLoss() == 0 && OrderTakeProfit() == 0)
              {
                  if(Debug == true) Print("Logic#3 Modify Order");
                  if(OrderModify(OrderTicket(), OrderOpenPrice(), PriceSell_SL, PriceSell_TP, 0, Red) == false) return(0);
              }

              //LotSelanjutnya = OrderLots() * 3;
              //if(MaxLot < LotSelanjutnya) {Print("Lot=",LotSelanjutnya," MaxLot=",MaxLot); return(0);}
              
              if(Debug == true) Print("Logic#3 Open BUYSTOP");
              Ticket = OpenOrder(OP_BUYSTOP, LotSelanjutnya, PriceBuy_OP, PriceBuy_SL, PriceBuy_TP, Blue);
              if(Ticket>0) OPSelanjutnya = OP_SELL;

              return(0);
         }
      }
      if(OPLast == OP_BUY)
      {
         //hitung price yg diperlukan
         if(OrderSelect(Ticket, SELECT_BY_TICKET) == true)
         {
              if(Debug == true) Print("Logic#3 Hitung Price - BUY");
              
              PriceBuy_OP = OrderOpenPrice();
              PriceBuy_TP = PriceBuy_OP  + PipDistance * MyPoint;
              Price3B = PriceBuy_OP  - PipDistance * MyPoint;
              PriceBuy_SL = Price3B  - PipDistance * MyPoint;
              
              PriceSell_SL = PriceBuy_TP;
              Price2S = PriceBuy_OP;
              PriceSell_OP = Price3B;
              PriceSell_TP = PriceBuy_SL;
              
              //Modify TP & SL
              if(OrderStopLoss() == 0 && OrderTakeProfit() == 0)
              {
                  if(Debug == true) Print("Logic#3 Modify Order");
                  if(OrderModify(OrderTicket(), OrderOpenPrice(), PriceBuy_SL, PriceBuy_TP, 0, Blue) == false) return(0);
              }
              //LotSelanjutnya = OrderLots() * 3;
              //if(MaxLot < LotSelanjutnya) {Print("Lot=",LotSelanjutnya," MaxLot=",MaxLot); return(0);}

              if(Debug == true) Print("Logic#3 Open SELLSTOP");
              Ticket = OpenOrder(OP_SELLSTOP, LotSelanjutnya, PriceSell_OP, PriceSell_SL, PriceSell_TP, Red);
              if(Ticket>0) OPSelanjutnya = OP_BUY;

              return(0);
         }      
      }

   }
   
   //buystop & sellstop sudah tereksekusi maka buka lagi
   if((OPBuy > 0 || OPSell > 0) && (OPBuyStop == 0 && OPSellStop == 0))
   {
      if(Debug == true) Print("Logic#4 Open OrderStop");
      if(LotSelanjutnya > 0)
      {
         if(OPLast == OP_SELL)
         {  
              if(Debug == true) Print("Logic#4 Open OrderStop - BUYSTOP");
              //if(MaxLot < LotSelanjutnya) {Print("Lot=",LotSelanjutnya," MaxLot=",MaxLot); return(0);}
           
              Ticket = OpenOrder(OP_BUYSTOP, LotSelanjutnya, PriceBuy_OP, PriceBuy_SL, PriceBuy_TP, Blue);
              if(Ticket>0) OPSelanjutnya = OP_SELL;
         }
         else
         if(OPLast == OP_BUY)
         {
              if(Debug == true) Print("Logic#4 Open OrderStop - SELLSTOP");
              //if(MaxLot < LotSelanjutnya) {Print("Lot=",LotSelanjutnya," MaxLot=",MaxLot); return(0);}
           
              Ticket = OpenOrder(OP_SELLSTOP, LotSelanjutnya, PriceSell_OP, PriceSell_SL, PriceSell_TP, Red);
              if(Ticket>0) OPSelanjutnya = OP_BUY;
         }
      }
   }   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+

void CloseAll()
{
   for (int i = OrdersTotal()-1 ; i >= 0; i--) 
   { 
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == true)
      { 
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderCloseTime() == 0) 
         { 
               if(OrderType() == OP_BUY)      OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, Blue); 
               if(OrderType() == OP_SELL)     OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, Red); 
               if(OrderType() == OP_SELLSTOP) OrderDelete(OrderTicket());
               if(OrderType() == OP_BUYSTOP)  OrderDelete(OrderTicket());
               Sleep(2000);
         } 
      } 
   } 
}

void DeleteSatuOrderStop()
{
   for (int i = OrdersTotal()-1 ; i >= 0; i--) 
   { 
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == true)
      { 
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderCloseTime() == 0) 
         { 
               if(OrderType() == OP_SELLSTOP) {OrderDelete(OrderTicket()); Sleep(2000); break;}
               if(OrderType() == OP_BUYSTOP)  {OrderDelete(OrderTicket()); Sleep(2000); break;}
         } 
      } 
   } 
}

int OpenOrder(int OPtype, double Lot, double OPprice, double SL, double TP, color clr)
{
     int Ticket=-1; 
     int OPt = OPtype; 

     if(OPtype == OP_SELLSTOP) OPt = OP_SELL;
     else if(OPtype == OP_BUYSTOP) OPt = OP_BUY;
       
     if(AccountFreeMarginCheck(Symbol(),OPt,Lot) <= 0 || GetLastError() == 134) 
     {
         Print("Bro, udah nggak punya Margin lagi nih, nggak bisa OP...");
     }
     else
     {
         Ticket = OrderSend(Symbol(), OPtype, Lot, OPprice, Slippage, SL, TP, StringConcatenate(ExpertName,"-",Symbol()), MagicNumber, 0, clr);               
     }
     return(Ticket);
}

bool TradeTime() 
{
   bool ret=false;
   if(StartTime<StopTime)
   {
      if (Hour() >= StartTime && Hour() <= StopTime) ret=true;
   }   
   else if(StartTime>StopTime)
   {
      if (Hour() >= StartTime || Hour() <= StopTime) ret=true;
   }
   return(ret); 
 }

bool CheckPair(int magic)
{
   bool ret = false;
   for (int cnt = 0; cnt < OrdersTotal(); cnt++) 
   {
      if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES) == true)
      {      
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == magic && OrderCloseTime() == 0) 
         {
            ret = true;
            break;
         }      
      }   
   }   
   return(ret);
}


//silahkan signal diganti...
int GetSignal()
{
   int signal = OP_BUY;
   
   double H, L, O, C, P;
   
   H = iHigh(Symbol(), PERIOD_D1, 1);
   L = iLow(Symbol(), PERIOD_D1, 1);
   C = iClose(Symbol(), PERIOD_D1, 1);
   
   O = iClose(Symbol(), PERIOD_D1, 0);
 
   P = (H + L + C) / 3;
   
   if(O > P) signal = OP_BUY;
   else signal = OP_SELL;
        
   return(signal);
}


